<?php
////////////////////////////////////////////////////////////////////////
//
//                   AnimeSpirit
//
//          Criado por Tlio Henrique Thom (Loki kun)
//          email loki@animespirit.com.br
//          icq 64196217
//          msn loki@animespirit.com.br
//
////////////////////////////////////////////////////////////////////////
// Verifica se o arquivo foi acessado direatmente
////////////////////////////////////////////////////////////////////////
if (eregi("backup.php", $_SERVER[PHP_SELF])) {
    $header_location = (@preg_match('/Microsoft|WebSTAR|Xitami/', $_SERVER['SERVER_SOFTWARE']))?'Refresh: 0; URL=':'Location: ';
    Header($header_location . '../administracao.php?op=backup');
    die();
}
////////////////////////////////////////////////////////////////////////
if (checkLogin()) {
    $obj = new backup();
} else {
    Header($header_location . append_sid(ENDERECO_NETWORK."administracao.php?op=login",true));
}
////////////////////////////////////////////////////////////////////////
class backup extends admin {
    var $tipo;
    function backup() {
        global $objSql, $objTemplate, $db_nome, $usuariodata, $config;
        $this->tipo  = $_REQUEST['tipo'];
        $admindata = $_COOKIE['admindata'];
        if ($_POST) {
            $backup_file = "# ========================================================\r\n";
            $backup_file .= "#\r\n";
            $backup_file .= "# Database: $db_nome\r\n";
            $backup_file .= "# Salvo em: ".data(time(), "%d/%m/%Y")."\r\n";
            $backup_file .= "# Por: $admindata[usuario]\r\n";
            $backup_file .= "# PHP: ".phpversion()."\r\n";
            $backup_file .= "#\r\n";
            $backup_file .= "# ========================================================\r\n";
            $backup_file .= "\r\n";
            $result = $objSql->sql_query("SHOW TABLE STATUS FROM $db_nome");
            while($row = $objSql->sql_fetchrow($result)) {
                $table_name = $row[0];
                if ($this->tipo != 'dados') {
                    $backup_file .= "\r\n#\r\n# TABELA: " . $table_name . "\r\n#\r\n";
                    $backup_file .= $this->get_table_def($table_name, "\r\n") . "\r\n";
                }
                if ($this->tipo != 'estrutura') {
                    $backup_file .= $this->get_table_content($table_name);
                }
            }
            $data = data(time(), "%d-%m-%Y");
            if ($_POST[compactar] == "bzip") {
                header("Content-type: application/x-bzip");
                header("Content-disposition: attachment; filename=$db_nome-$data.sql.bz2");
                header("Expires: 0");
                echo bzcompress($backup_file);
            } elseif ($_POST[compactar] == "gzip") {
                header("Content-type: application/x-gzip");
                header("Content-disposition: attachment; filename=$db_nome-$data.sql.gz");
                header("Expires: 0");
                echo gzencode($backup_file);
            } elseif ($_POST[compactar] == "zip") {
                header("Content-type: application/x-zip");
                header("Content-disposition: attachment; filename=$db_nome-$data.zip");
                header("Expires: 0");
                $zipfile = new zipfile();
                $zipfile->add_file($backup_file, "$db_nome-$data.sql");
                echo $zipfile->file();
            } else {
                header("Content-type: application/octetstream");
                header("Content-disposition: attachment; filename=$db_nome-$data.sql");
                echo $backup_file;
            }
        } else {
            $title_dir = "Administrao :: Backup";
            $menu_dir = "<a href=\"".append_sid(ENDERECO_NETWORK.'administracao.php',true)."\">Administrao</a>/Backup";
            include(ROOT_DIR . 'administracao/menu.php');
            include(ROOT_DIR . "include/topo.php");
            $objTemplate->set_filenames(array('body' => 'administracao/backup_body.html'));
            $objTemplate->assign_vars(array(
                    'form_action' => append_sid(ENDERECO_NETWORK . "administracao.php?op=backup",true))
            );
            $objTemplate->pparse('body');
            include(ROOT_DIR . "include/rodape.php");
            $objSql->sql_close();
        }
    }
    function get_table_def($table_name, $crlf) {
        global $objSql, $drop;
        $schema_create = "";
        $field_query = "SHOW FIELDS FROM $table_name";
        $key_query = "SHOW KEYS FROM $table_name";
        if ($drop == 1) {
            $schema_create .= "DROP TABLE IF EXISTS $table_name;$crlf";
        }
        $schema_create .= "CREATE TABLE $table_name($crlf";
        $result = $objSql->sql_query($field_query);
        if (!$result) {
            message_die(GENERAL_ERROR, "Failed in get_table_def (show fields)", "", __LINE__, __FILE__, $field_query);
        }
        while($row = $objSql->sql_fetchrow($result)) {
    	$schema_create .= '	' . $row['Field'] . ' ' . $row['Type'];
    	if (!empty($row['Default'])) {
    	    $schema_create .= ' DEFAULT \'' . $row['Default'] . '\'';
    	}
    	if ($row['Null'] != "YES") {
    	    $schema_create .= ' NOT NULL';
    	}
    	if ($row['Extra'] != "") {
    	    $schema_create .= ' ' . $row['Extra'];
    	}
    	$schema_create .= ",$crlf";
        }
        $schema_create = ereg_replace(',' . $crlf . '$', "", $schema_create);
        $result = $objSql->sql_query($key_query);
        if (!$result) {
            message_die(GENERAL_ERROR, "FAILED IN get_table_def (show keys)", "", __LINE__, __FILE__, $key_query);
        }
        while($row = $objSql->sql_fetchrow($result)) {
    	$kname = $row['Key_name'];
    	if (($kname != 'PRIMARY') && ($row['Non_unique'] == 0)) {
    	    $kname = "UNIQUE|$kname";
    	}
    	if (!is_array($index[$kname])) {
    	    $index[$kname] = array();
    	}
    	$index[$kname][] = $row['Column_name'];
        }
        while(list($x, $columns) = @each($index)) {
    	$schema_create .= ", $crlf";
    	if ($x == 'PRIMARY') {
    	    $schema_create .= '	PRIMARY KEY (' . implode($columns, ', ') . ')';
    	} elseif (substr($x,0,6) == 'UNIQUE') {
    	    $schema_create .= '	UNIQUE ' . substr($x,7) . ' (' . implode($columns, ', ') . ')';
    	} else {
    	    $schema_create .= "	KEY $x (" . implode($columns, ', ') . ')';
    	}
        }
        $schema_create .= "$crlf);";
        if (get_magic_quotes_runtime()) {
            return(stripslashes($schema_create));
        } else {
            return($schema_create);
        }
    }
    function get_table_content($table_name) {
        global $objSql;
        $result = $objSql->sql_query("SELECT * FROM $table_name");
        if (!$result) {
            message_die(GENERAL_ERROR, "Failed in get_table_content (select *)", "", __LINE__, __FILE__, "SELECT * FROM $table_name");
        }
        if ($objSql->sql_numrows($result) > 0) {
            $schema_insert = "\r\n#\r\n# DADOS: $table_name\r\n#\r\n";
        } else {
            $schema_insert = "";
        }
        while($row = $objSql->sql_fetchrow($result)) {
            $num_fields = $objSql->sql_numfields($result);
            $schema_insert .= "INSERT INTO $table_name VALUES(";
            for($j = 0; $j < $num_fields; $j++) {
                if (!isset($row[$j])) {
                    $schema_insert .= ' NULL,';
                } elseif ($row[$j] != '') {
                    $schema_insert .= '\'' . addslashes($row[$j]) . '\',';
                 } else {
                     $schema_insert .= '\'\',';
                 }
            }
            $schema_insert = ereg_replace(',$', '', $schema_insert);
            $schema_insert .= ");\r\n";
        }
        $schema_insert .= "# --------------------------------------------------------\r\n\r\n";
        return(trim($schema_insert));
    }
}
////////////////////////////////////////////////////////////////////////
?>
