<?php
////////////////////////////////////////////////////////////////////////
//
//                   AnimeSpirit
//
//          Criado por Tlio Henrique Thom (Loki kun)
//          email loki@animespirit.com.br
//          icq 64196217
//          msn loki@animespirit.com.br
//
////////////////////////////////////////////////////////////////////////
// Inclui funes e variaiveis
////////////////////////////////////////////////////////////////////////
define('ROOT_DIR','./');
include(ROOT_DIR . "common.php");
////////////////////////////////////////////////////////////////////////
if ($_POST) {
    ////////////////////////////////////////////////////////////////////////
    // Verifica se todos os campos foram preenchidos
    ////////////////////////////////////////////////////////////////////////
    if (empty($_POST['nome']))      $erro[] = "Voc no colocou o Nome do Site";
    if (empty($_POST['url']))       $erro[] = "Voc no colocou o Endereo do site";
    if (empty($_POST['descricao'])) $erro[] = "Voc no colocou a Descrio do site";
    if (empty($_POST['destaque']))  $erro[] = "Voc no colocou o Destaque do site";
    if (empty($_POST['cat_id']))    $erro[] = "Voc no escolheu uma Categoria do site";
    if (empty($_POST['botao']))     $erro[] = "Voc no colocou o Boto do site";
    if (empty($_POST['webmaster'])) $erro[] = "Voc no colocou o Webmaster";
    if (empty($_POST['email']))     $erro[] = "Voc no colocou o E-mail";
    if ($_POST['senha'] != $_POST['senha2']) $erro[] = "Verifique as senhas pois elas so diferentes";
    ////////////////////////////////////////////////////////////////////////
    // Verifica se ja no tem um site com o mesmo nome
    ////////////////////////////////////////////////////////////////////////
    $sql = "SELECT * FROM animespirit_network_sites WHERE nome='$_POST[nome]'";
    if (!($result = $objSql->sql_query($sql))) {
        message_die(GENERAL_ERROR, 'Falha ao pegar dados da tabela', '', __LINE__, __FILE__, $sql);
    }
    if ($objSql->sql_numrows($result) > 0) $erro[] = "O site $_POST[nome] ja esta cadastrado!!!";
    ////////////////////////////////////////////////////////////////////////
    // Se tiver tudo ok adiciona o site no network
    ////////////////////////////////////////////////////////////////////////
    if (empty($erro)) {
        if (!stristr($_POST[url],"://"))   $_POST[url]="http://".$_POST[url];
        if (!stristr($_POST[botao],"://")) $_POST[botao]="http://".$_POST[botao];
        $senha = $_POST['senha'];
        $cryptsenha = md5($senha);
        $sql = "INSERT INTO animespirit_network_sites VALUES (NULL,'$_POST[nome]','$_POST[url]','$_POST[descricao]','$_POST[destaque]','$_POST[cat_id]','$_POST[botao]','$_POST[webmaster]','$_POST[email]','$cryptsenha')";
        if (!($result = $objSql->sql_query($sql))) {
            message_die(GENERAL_ERROR, 'Falha ao adicionar dados da tabela', '', __LINE__, __FILE__, $sql);
        }
        $id = $objSql->sql_nextid();

        $assunto = "Bem-vindo ao AnimeSpirit Network $_POST[usuario]";
        $objEmailer = new emailer($config['smtp']['ativado']);
        $email_headers = 'From: AnimeSpirit <'.$config[email] .">\nReturn-Path: " . $config[email] . "\r\nContent-Type: text/html; charset=iso-8859-1\r\n";
        $objEmailer->use_template('cadastrar');
        $objEmailer->email_address($_POST[email]);
        $objEmailer->set_subject($assunto);
        $objEmailer->extra_headers($email_headers);
        $objEmailer->assign_vars(array(
              'id' => $id,
              'email' => $_POST['email'],
              'senha' => $_POST['senha'],
              'codigo' => htmlspecialchars('<a href="'.ENDERECO_NETWORK.'index.php?id='.$id.'"><img src="'.ENDERECO_NETWORK.'img.php?id='.$id.'" alt="AnimeSpirit Network" border="0"></a>'))
        );
        $objEmailer->send();
        $objEmailer->reset();
        $info = base64_encode("$id:$cryptsenha");
        setcookie("network",$info);
        echo '<script>';
        echo 'alert("Site cadastrado com sucesso!\n\nAgora coloque o nosso boto na pgina principal do seu Website.\n\nSeu ID : '.$id.'\nSua Senha : '. $senha.'");';
        echo 'window.location = "'.append_sid(ENDERECO_NETWORK . "codigo.php",true).'";';
        echo '</script>';
    }
}
////////////////////////////////////////////////////////////////////////
// Seta o titulo e inclui a parte superior
////////////////////////////////////////////////////////////////////////
$title_dir = "Cadastrar";
$menu_dir = "Cadastrar";
include(ROOT_DIR . "include/topo.php");
////////////////////////////////////////////////////////////////////////
// Seta o arquivo utilizado do template
///////////////////////////////////////////////////////////////////////
$objTemplate->set_filenames(array('body' => 'cadastrar_body.html'));
////////////////////////////////////////////////////////////////////////
// Adiciona os dados no template
////////////////////////////////////////////////////////////////////////
$objTemplate->assign_vars(array(
        'form_action' => append_sid(ENDERECO_NETWORK . "cadastrar.php?regras=true",true),
        'select_cat' => select('cat_id',$_POST['cat_id'], 'SELECT * FROM animespirit_network_categorias ORDER BY nome ASC'),
        'nome' => (!empty($erro))?stripslashes($_POST['nome']):'',
        'url' => (!empty($erro))?stripslashes($_POST['url']):'http://',
        'descricao' => (!empty($erro))?stripslashes($_POST['descricao']):'',
        'destaque' => (!empty($erro))?stripslashes($_POST['destaque']):'',
        'botao' => (!empty($erro))?stripslashes($_POST['botao']):'http://',
        'webmaster' => (!empty($erro))?stripslashes($_POST['webmaster']):'',
        'email' => (!empty($erro))?stripslashes($_POST['email']):'')
);
////////////////////////////////////////////////////////////////////////
// Adiciona os erros (se houver)
////////////////////////////////////////////////////////////////////////
if ((!empty($erro)) AND ($_POST)) {
    $objTemplate->assign_block_vars('erro', array(
            'msg' => implode($erro, "<br>\n"))
    );
}
////////////////////////////////////////////////////////////////////////
// Finaliza o template e inclui a parte de baixo do site
////////////////////////////////////////////////////////////////////////
$objTemplate->pparse('body');
include(ROOT_DIR . "include/rodape.php");
////////////////////////////////////////////////////////////////////////
// Finaliza o Banco de dados
////////////////////////////////////////////////////////////////////////
$objSql->sql_close();
////////////////////////////////////////////////////////////////////////
?>