<?php
////////////////////////////////////////////////////////////////////////
//
//                   AnimeSpirit
//
//          Criado por Tlio Henrique Thom (Loki kun)
//          email loki@animespirit.com.br
//          icq 64196217
//          msn loki@animespirit.com.br
//
////////////////////////////////////////////////////////////////////////
// Inclui funes e variaiveis
////////////////////////////////////////////////////////////////////////
define('ADMIN', TRUE);
define('ROOT_DIR', './');
include(ROOT_DIR . "common.php");
////////////////////////////////////////////////////////////////////////
// Desativa o cache do navegador
////////////////////////////////////////////////////////////////////////
header("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1 
header("Pragma: no-cache"); // HTTP/1.0
////////////////////////////////////////////////////////////////////////
// Verifica o login e permisso
////////////////////////////////////////////////////////////////////////
if (!checkLogin()) {
    include(ROOT_DIR . "administracao/login.php");
} else {
    $objAdmin = new admin();
}
////////////////////////////////////////////////////////////////////////
class admin {
    var $area;
    function admin() {
        global $objSql, $usuariodata, $grupodata;
        $this->op = $_REQUEST['op'];
        switch($this->op) {
            case "backup":
               include(ROOT_DIR . "administracao/backup.php");
            break;
            case "configuracoes":
               include(ROOT_DIR . "administracao/configuracoes.php");
            break;
            case "otimizar":
               include(ROOT_DIR . "administracao/otimizar.php");
            break;
            case "network":
               include(ROOT_DIR . "administracao/network.php");
            break;
            case "usuario":
               include(ROOT_DIR . "administracao/usuario.php");
            break;
            case "logoff":
               include(ROOT_DIR . "administracao/logoff.php");
            break;
            default:
               $this->index();
            break;
        }
    }
    function index() {
        global $objSql, $objTemplate, $config, $header_location;
        if ($_POST) {
            $sql = "SELECT * FROM animespirit_network_sites WHERE nome='$_POST[nome]'";
            if (!($result = $objSql->sql_query($sql))) {
                message_die(GENERAL_ERROR, 'Falha ao pegar dados da tabela', '', __LINE__, __FILE__, $sql);
            }             
            if ($row = $objSql->sql_fetchrow($result)) {
                $sql = "SELECT * FROM animespirit_network_config WHERE config_nome='site_destaque_id'";
                if (!($result = $objSql->sql_query($sql))) {
                    message_die(GENERAL_ERROR, 'Falha ao pegar dados da tabela', '', __LINE__, __FILE__, $sql);
                }
                if ($objSql->sql_numrows($result)>0) {
                    $sql = "UPDATE animespirit_network_config SET config_value='$row[id]' WHERE config_nome='site_destaque_id'";
                    if (!($request = $objSql->sql_query($sql))) {
                        message_die(GENERAL_ERROR, 'Falha ao atualizar dados da tabela', '', __LINE__, __FILE__, $sql);
                    }
                } else {
                    $sql = "INSERT INTO animespirit_network_config VALUES ('site_destaque_id','$row[id]')";
                    if (!($request = $objSql->sql_query($sql))) {
                        message_die(GENERAL_ERROR, 'Falha ao adicionar dados da tabela', '', __LINE__, __FILE__, $sql);
                    }
                }
            }
            header($header_location . append_sid(ENDERECO_NETWORK . "administracao.php",true));
        }
        $title_dir = "Administrao";
        $menu_dir = "Administrao";
        include(ROOT_DIR . "include/topo.php");
        include(ROOT_DIR . 'administracao/menu.php');
        $objTemplate->set_filenames(array('body' => 'administracao/index_body.html'));
        $objTemplate->assign_vars(array(
                'form_action' => append_sid(ENDERECO_NETWORK . "administracao.php",true))
        );
        $objTemplate->pparse('body');
        include(ROOT_DIR . "include/rodape.php");
    }
}
////////////////////////////////////////////////////////////////////////
?>
