<?php
////////////////////////////////////////////////////////////////////////
//
//                   AnimeSpirit
//
//          Criado por Tlio Henrique Thom (Loki kun)
//          email loki@animespirit.com.br
//          icq 64196217
//          msn loki@animespirit.com.br
//
////////////////////////////////////////////////////////////////////////
// Verifica se o arquivo foi acessado direatmente
////////////////////////////////////////////////////////////////////////
if (eregi("smtp.php", $_SERVER[PHP_SELF])) {
    $header_location = (@preg_match('/Microsoft|WebSTAR|Xitami/', $_SERVER['SERVER_SOFTWARE']))?'Refresh: 0; URL=':'Location: ';
    Header($header_location . "../index.php");
    die();
}
////////////////////////////////////////////////////////////////////////
define('SMTP_INCLUDED', 1);
////////////////////////////////////////////////////////////////////////
function server_parse($socket, $response) { 
   while (substr($server_response,3,1) != ' ') { 
      if (!($server_response = fgets($socket, 256))) { 
          message_die(GENERAL_ERROR, "Couldn't get mail server response codes", "", __LINE__, __FILE__); 
      } 
   } 
   if (!(substr($server_response, 0, 3) == $response)) { 
       message_die(GENERAL_ERROR, "Ran into problems sending Mail. Response: $server_response", "", __LINE__, __FILE__); 
   } 
} 
////////////////////////////////////////////////////////////////////////
function smtpmail($mail_para, $assunto, $mensagem, $headers = "") {
    global $objSql, $config;
    $mensagem = preg_replace("/(?<!\r)\n/si", "\r\n", $mensagem);
    if ($headers != "") {
        if (is_array($headers)) {
            if (sizeof($headers) > 1) {
                $headers = join("\r\n", $headers);
            } else {
     	        $headers = $headers[0];
            }
        }
        $headers = chop($headers);
        $headers = preg_replace("/(?<!\r)\n/si", "\r\n", $headers);
        $header_array = explode("\r\n", $headers);
        @reset($header_array);
        $headers = "";
        while (list(, $header) = each($header_array)) {
            if (preg_match("/^cc:/si", $header)) {
                $cc = preg_replace("/^cc:(.*)/si", "\\1", $header);
            } elseif (preg_match("/^bcc:/si", $header)) {
                $bcc = preg_replace("/^bcc:(.*)/si", "\\1", $header);
                $header = "";
            }
            $headers .= $header . "\r\n";
        }
        $headers = chop($headers);
        $cc = explode(",", $cc);
        $bcc = explode(",", $bcc);
    }
    if (trim($mail_para) == "") {
        message_die(GENERAL_ERROR, "No email address specified", "", __LINE__, __FILE__);
    }
    if (trim($assunto) == "") {
        message_die(GENERAL_ERROR, "No email Subject specified", "", __LINE__, __FILE__);
    }
    if (trim($mensagem) == "") {
        message_die(GENERAL_ERROR, "Email message was blank", "", __LINE__, __FILE__);
    }
    $mail_para_array = explode(",", $mail_para);
    if (!$socket = fsockopen($config[smtp_host], 25, $errno, $errstr, 20)) {
        message_die(GENERAL_ERROR, "Could not connect to smtp host : $errno : $errstr", "", __LINE__, __FILE__);
    }
    server_parse($socket, "220");
    if (isset($config[smtp_usuario]) && isset($config[smtp_senha])) { 
        fputs($socket, "EHLO " . $config[smtp_host] . "\r\n"); 
        server_parse($socket, "250"); 
        fputs($socket, "AUTH LOGIN\r\n"); 
        server_parse($socket, "334"); 
        fputs($socket, base64_encode($config[smtp_usuario]) . "\r\n"); 
        server_parse($socket, "334"); 
        fputs($socket, base64_encode($config[smtp_senha]) . "\r\n"); 
        server_parse($socket, "235"); 
    } else { 
        fputs($socket, "HELO " . $config[smtp_host] . "\r\n"); 
        server_parse($socket, "250"); 
    }
    fputs($socket, "MAIL FROM: <" . $config[email] . ">\r\n");
    server_parse($socket, "250");
    $to_header = "To: ";
    @reset($mail_para_array);
    while (list( , $mail_para_endereco) = each($mail_para_array)) {
        $mail_para_endereco = trim($mail_para_endereco);
        if (preg_match('/[^ ]+\@[^ ]+/', $mail_para_endereco))	{
    	    fputs( $socket, "RCPT TO: <$mail_para_endereco>\r\n" );
            server_parse( $socket, "250" );
        }
        $to_header .= "<$mail_para_endereco>, ";
    }
    @reset($bcc);
    while (list( , $bcc_endereco) = each($bcc)) {
        $bcc_endereco = trim( $bcc_endereco );
        if (preg_match('/[^ ]+\@[^ ]+/', $bcc_endereco)) {
            fputs( $socket, "RCPT TO: <$bcc_endereco>\r\n" );
            server_parse( $socket, "250" );
        }
    }
    @reset($cc);
    while (list( , $cc_endereco) = each($cc)) {
        $cc_endereco = trim( $cc_endereco );
        if (preg_match('/[^ ]+\@[^ ]+/', $cc_endereco)) {
            fputs($socket, "RCPT TO: <$cc_endereco>\r\n");
            server_parse($socket, "250");
        }
    }
    fputs($socket, "DATA\r\n");
    server_parse($socket, "354");
    fputs($socket, "Subject: $assunto\r\n");
    fputs($socket, "$to_header\r\n");
    fputs($socket, "$headers\r\n\r\n");
    fputs($socket, "$mensagem\r\n");
    fputs($socket, ".\r\n");
    server_parse($socket, "250");
    fputs($socket, "QUIT\r\n");
    fclose($socket);
    return TRUE;
}
////////////////////////////////////////////////////////////////////////
?>